//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "polim.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

void polinulo(polim& p)
{p.ult=-1;}

bool esnulo(polim p)
{return (p.ult==-1);}

void busca_exp(mono v[N],int x,int c, int f, bool& existe,int& pos)
{
  int m;
 if (c>f)
  {existe=false;
   pos=c;
  }
 else
  {m = (c+f)/2;
   if (v[m].exp==x)
    {existe=true;
     pos=m;
    }
   else if (v[m].exp<x)
    {busca_exp(v,x,m+1,f,existe,pos);}
   else {busca_exp(v,x,c,m-1,existe,pos);}
  }
}

void desplaza_der(mono v[N],int a,int b)
{for (int i=b;i>=a;i--) {v[i+1]=v[i];};}

void suma_mono(int c,int i,polim& p)
{
 bool existe;
 int pos;
 if (c>0)
  {busca_exp(p.monoms,i,0,p.ult,existe,pos);
   if (existe)
    {p.monoms[pos].coef=p.monoms[pos].coef + c;}
   else
    { if (p.ult==N-1) {throw Exception("Overflow");}
      else
       {desplaza_der(p.monoms,pos,p.ult);
        p.monoms[pos].coef=c;
        p.monoms[pos].exp=i;
        p.ult=p.ult+1;
       }
    };
   }
}

void suma(polim& p,polim q)
{for (int i=0;i<=p.ult;i++)
  {suma_mono(q.monoms[i].coef,q.monoms[i].exp,p);}
}


void copia(polim r,polim& p)
{
 polinulo(p);
 p.ult=r.ult;
 for (int i=0;i<=p.ult;i++)
  {p.monoms[i].coef=r.monoms[i].coef;
   p.monoms[i].exp=r.monoms[i].exp;
  }
}

void mult(polim& p,polim q)
{polim r;
 polinulo(r);
 for (int i=0;i<=q.ult;i++)
  for (int j=0;j<=p.ult;j++)
   {suma_mono(q.monoms[i].coef*p.monoms[j].coef,
              q.monoms[i].exp+p.monoms[j].exp,r);
   };
 copia(r,p);
}

int coef(int i,polim p)
{int c;
 bool existe;
 int pos;
 busca_exp(p.monoms,i,0,p.ult,existe,pos);
 if (existe) {c=p.monoms[pos].coef;}
 else {c=0;};
 return c;
}

int grado(polim p)
{int g;
 if (!(p.ult==-1)) {g=p.monoms[p.ult].exp;}
 else {g=0;};
 return g;
}
 int potencia(int b,int exp)
{int p;
 if (exp==0) {p=1;}
 else if (exp>0) {p=b*potencia(b,exp-1);}
 else {throw Exception("Exponente negativo");}
 return p;
}

int eval(polim p,int x)
{int w=0;
 if (x>=0)
 {
 for (int i=0;i<=p.ult;i++)
  {w=w+p.monoms[i].coef*potencia(x,p.monoms[i].exp);};
 }
 else {throw Exception("No natural");};
 return w;
}


